<id>
din1031:AttachmentFileRenamer
</id>

<version>
1.2.0
</version>

<edit file>
$boarddir/index.php
</edit file>

<search for>
		'announce' => array('Post.php', 'AnnounceTopic'),
</search for>

<add after>
		'attachrenamefix' => array('ManageAttachments.php', 'AttachmentsRenameFix'),
		'attachrename' => array('ManageAttachments.php', 'RenameAttachmentsPost'),
		'attachrename2' => array('ManageAttachments.php', 'RenameAttachments2'),
</add after>

<edit file>
$sourcedir/Display.php
</edit file>

<search for>
				'name' => htmlspecialchars($attachment['filename']),
</search for>

<replace>
				'name' => empty($attachment['renamedfilename']) ? htmlspecialchars($attachment['filename']) : $attachment['renamedfilename'],
</replace>

<search for>
				'link' => '<a href="' . $scripturl . '?action=dlattach;topic=' . $topic . '.0;attach=' . $attachment['ID_ATTACH'] . '">' . htmlspecialchars($attachment['filename']) . '</a>',
</search for>

<replace>
				'link' => '<a href="' . $scripturl . '?action=dlattach;topic=' . $topic . '.0;attach=' . $attachment['ID_ATTACH'] . '">' . (empty($attachment['renamedfilename']) ? htmlspecialchars($attachment['filename']) : $attachment['renamedfilename']) . '</a>',
</replace>

<search for>
					a.ID_ATTACH, a.ID_MSG, a.filename, a.file_hash, IFNULL(a.size, 0) AS filesize, a.downloads,
</search for>

<add after>
					a.renamedfilename,
</add after>

<search for>
	if (empty($options['view_newest_first']))
		$counter++;
	else
		$counter--;
</search for>

<add after>

	// Can Rename Attachments?
	$output['can_rename_attachment'] = !empty($output['attachment']) && (allowedTo('rename_attachments_any') || allowedTo('rename_attachments_own') && $ID_MEMBER == $message['ID_MEMBER']);
</add after>

<search for>
			SELECT filename, ID_ATTACH, attachmentType, file_hash
</search for>

<replace>
			SELECT filename, ID_ATTACH, attachmentType, file_hash, renamedfilename
</replace>

<search for>
			SELECT a.filename, a.ID_ATTACH, a.attachmentType, a.file_hash
</search for>

<replace>
			SELECT a.filename, a.ID_ATTACH, a.attachmentType, a.file_hash, a.renamedfilename
</replace>

<search for>
	list ($real_filename, $ID_ATTACH, $attachmentType, $file_hash) = mysql_fetch_row($request);
</search for>

<replace>
	list ($real_filename, $ID_ATTACH, $attachmentType, $file_hash, $renamedfilename) = mysql_fetch_row($request);
</replace>

<search for>
	// Update the download counter (unless it's a thumbnail).
</search for>

<add before>
	// if the renamed filename empty than i replace it with teh orginal :) And remove some not so nice html inserts ;D
	if (!empty($modSettings['attachmentCheckCensor']))
	{
		$pregReplace = !empty($renamedfilename);
		$renamedfilename = empty($renamedfilename) ? $real_filename : $renamedfilename;
		censorText($renamedfilename);
		if ($pregReplace)
			$renamedfilename = preg_replace('%(&)(.*?)(;)%is', '_', $renamedfilename);
	}
	else	
		$renamedfilename = empty($renamedfilename) ? $real_filename : preg_replace('%(&)(.*?)(;)%is', '_', $renamedfilename);
	
</add before>

<search for>
	header('Content-Disposition: ' . (isset($_REQUEST['image']) ? 'inline' : 'attachment') . '; filename="' . $real_filename . '"');
</search for>

<replace>
	header('Content-Disposition: ' . (isset($_REQUEST['image']) ? 'inline' : 'attachment') . '; filename="' . $renamedfilename . '"');
</replace>

</search for>
	if (!isset($_REQUEST['image']) && in_array(substr($real_filename, -4), array('.gif', '.jpg', '.bmp', '.png', 'jpeg', 'tiff')))
</search for>

<replace>
	if (!isset($_REQUEST['image']) && in_array(substr($renamedfilename, -4), array('.gif', '.jpg', '.bmp', '.png', 'jpeg', 'tiff')))
</replace>

<search for>
			if (!$attachmentData[$i]['is_image'])
				continue;
</search for>

<replace>
			// Censore Text of the Attachments
			if (!empty($modSettings['attachmentCheckCensor'])) 
				censorText($attachmentData[$i]['name']);

			if (!$attachmentData[$i]['is_image'])
				continue;
</replace>

<edit file>
$sourcedir/Security.php
</edit file>

<search for>
			'move_any',
			'send_topic',
</search for>

<add after>
			'rename_attachments_own', 'rename_attachments_any',
</add after>

<edit file>
$sourcedir/ManageAttachments.php
</edit file>

<search for>
	$context['template_layers'][] = 'manage_files';
</search for>

<add after>
	// Redirected subaction i know this should not be done but... it's the easiest way XD
	if (!empty($_REQUEST['rename']))
	{
		$_GET['sa'] = 'rename';
		$_REQUEST['sa'] = 'rename';
	}
</add after>

<search for>
		'remove' => 'RemoveAttachment',
</search for>

<add after>
		'rename' => 'RenameAttachments',
</add after>

<search for>
			'attachmentThumbHeight' => (int) $_POST['attachmentThumbHeight'],
</search for>

<replace>
			'attachmentThumbHeight' => (int) $_POST['attachmentThumbHeight'],
			'attachmentCheckCensor' => empty($_POST['attachmentCheckCensor']) ? '0' : '1',
</replace>

<search for>
		'name' => 'a.filename',
</search for>

<replace>
		'realname' => 'a.filename',
		'name' => 'a.renamedfilename', 
</replace>

<search for>
			FROM {$db_prefix}attachments AS a
				LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = a.ID_MEMBER)
</search for>

<add before>
				, a.renamedfilename
</add before>

<search for>
				a.ID_ATTACH, a.filename, a.attachmentType, a.size, a.width, a.height, a.downloads, mf.subject, t.ID_BOARD
</search for>

<add after>
				, a.renamedfilename
</add after>

<search for>
	$context['posts'] = array();
	while ($row = mysql_fetch_assoc($request))
</search for>

<replace>
	$context['posts'] = array();
	while ($row = mysql_fetch_assoc($request))
	{
		// Attchment Censore
		if (!empty($modSettings['attachmentCheckCensor']))
		{
			censorText($row['renamedfilename']);
			censorText($row['filename']);
		}
</replace>

<search for>
		);
	mysql_free_result($request);
}
</search for>

<replace>
		);
	}
	mysql_free_result($request);
}
</replace>

<search for>
				'name' => htmlspecialchars($row['filename']),
</search for>

<replace>
				'name' => $row['renamedfilename'],
				'realname' => htmlspecialchars($row['filename']),
</replace>

<search for>
				'link' => '<a href="' . ($row['attachmentType'] == 1 ? $modSettings['custom_avatar_url'] . '/' . $row['filename'] : ($scripturl . '?action=dlattach;' . ($context['browse_type'] == 'avatars' ? 'type=avatar;' : 'topic=' . $row['ID_TOPIC'] . '.0;') . 'id=' . $row['ID_ATTACH'])) . '"' . (empty($row['width']) || empty($row['height']) ? '' : ' onclick="return reqWin(this.href + \';image\', ' . ($row['width'] + 20) . ', ' . ($row['height'] + 20) . ', true);"') . '>' . htmlspecialchars($row['filename']) . '</a>'
</search for>

<replace>
				'link' => '<a href="' . ($row['attachmentType'] == 1 ? $modSettings['custom_avatar_url'] . '/' . $row['filename'] : ($scripturl . '?action=dlattach;' . ($context['browse_type'] == 'avatars' ? 'type=avatar;' : 'topic=' . $row['ID_TOPIC'] . '.0;') . 'id=' . $row['ID_ATTACH'])) . '"' . (empty($row['width']) || empty($row['height']) ? '' : ' onclick="return reqWin(this.href + \';image\', ' . ($row['width'] + 20) . ', ' . ($row['height'] + 20) . ', true);"') . '>' . (empty($row['renamedfilename']) ? htmlspecialchars($row['filename']) : $row['renamedfilename']) . '</a><br /><span class="smalltext">(' . $row['filename'] . ')</span>'.(empty($row['renamedfilename']) ? ' <a href="'.$scripturl.'?action=attachrenamefix"><span class="error"><span class="smalltext"><u>'.$txt['attachemptyrename'].'</u></span></span></a>' : ''),
</replace>

<search for>
?>
</search for>

<add before>
function AttachmentsRenameFix()
{
	global $txt, $db_prefix;

	// You have to be able to moderate the forum to do this.
	isAllowedTo('manage_attachments');
	
	// Okay it's fast an clean ;D
	db_query("
		UPDATE {$db_prefix}attachments 
		SET renamedfilename = filename 
		WHERE renamedfilename = ''", __FILE__, __LINE__);
	
	redirectexit('action=manageattachments');
}

function RenameAttachments()
{
	global $db_prefix, $modSettings, $txt, $context;

	checkSession('post');

	if (!empty($_POST['remove']))
	{
		$attachments = array();
		// There must be a quicker way to pass this safety test??
		foreach ($_POST['remove'] as $removeID => $dummy)
			$attachments[] = (int) $removeID;
		
		$context['attachments'] = array();
		
		// Load the Attachment Renamednames ;D
		$request = db_query("
			SELECT ID_ATTACH, renamedfilename, filename
			FROM {$db_prefix}attachments
			WHERE ID_ATTACH IN (".implode(", ", $attachments).")
			LIMIT ".count($attachments), __FILE__, __LINE__);
		
		while ($row = mysql_fetch_assoc($request)) 
			$context['attachments'][] = array(
				'ID_ATTACH' => $row['ID_ATTACH'],
				'renamedfilename' => empty($row['renamedfilename']) ? $row['filename'] : $row['renamedfilename'],
			);
		
		mysql_free_result($request);
	
		// Load the template ;)
		$context['page_title'] = $txt['attachment_manager_rename_files'];
		$context['description'] = $txt['attachment_manager_rename_files'];
		$context['selected'] = 'browse';
		$context['sub_template'] = 'manage_rename';
	}
	else 
		redirectexit('action=manageattachments');
	
}

function RenameAttachmentsPost()
{
	global $db_prefix, $modSettings, $txt, $context, $ID_MEMBER, $topic;

	checkSession('get');

	// Let's look the for the id of the member :)
	if (empty($topic) || empty($_GET['msg']) || !is_numeric($_GET['msg']))
		fatal_error($txt['notopicoridfound']);
	elseif (!allowedTo('rename_attachments_any') && !allowedTo('rename_attachments_own'))
		fatal_error($txt['norightstorename']);
	elseif (!allowedTo('rename_attachments_any'))
	{
		$poster = db_query("SELECT ID_MEMBER FROM {$db_prefix}messages WHERE ID_MSG = $_GET[msg] LIMIT 1", __FILE__, __LINE__);
		list($ID_MEMBER_POSTER) = mysql_fetch_row($poster);
		mysql_free_result($poster);
		
		if (!(allowedTo('rename_attachments_own') && $ID_MEMBER_POSTER == $ID_MEMBER))
			fatal_error($txt['norightstorename']);
	}

	// Load the template ;)
	loadTemplate('ManageAttachments');
	
	// Load the attachments :)
	$context['attachments'] = array();
	
	// Load the Attachment Renamednames ;D
	$request = db_query("
		SELECT ID_ATTACH, renamedfilename, filename
		FROM {$db_prefix}attachments
		WHERE ID_MSG = $_GET[msg]
			AND attachmentType != 3", __FILE__, __LINE__);
	
	while ($row = mysql_fetch_assoc($request)) 
		$context['attachments'][] = array(
			'ID_ATTACH' => $row['ID_ATTACH'],
			'renamedfilename' => empty($row['renamedfilename']) ? $row['filename'] : $row['renamedfilename'],
		);
	
	mysql_free_result($request);
	
	if (empty($context['attachments']))
		fatal_error($txt['notopicoridfound']);
	
	$context['topic'] = $topic;
	$context['ID_MSG'] = $_GET['msg'];
	
	$context['page_title'] = $txt['attachment_manager_rename_files'];
	$context['description'] = $txt['attachment_manager_rename_files'];
	$context['template_layers'][] = 'manage_rename2';
}

function RenameAttachments2()
{
	global $db_prefix, $modSettings, $txt, $func, $topic, $ID_MEMBER;

	checkSession('post');

	// First check if the user is allowed to do this
	if (!allowedTo('rename_attachments_any') && !allowedTo('rename_attachments_own'))
		fatal_error($txt['norightstorename']);
		
	// Okay Rename it :)
	if (!empty($_POST['renameto']))
	{
		$empty_to_old = array();
		$new_names = array();
		// Okay Let's rename it :)
		foreach ($_POST['renameto'] as $ID_ATTACH => $newname)
		{
			if (empty($newname) || $func['htmltrim']($newname) === '')
				$empty_to_old[] = $ID_ATTACH;
			else
			{
				// Remove all the not wantet letters *g*
				// Most system dont like this ;)
				$newname = str_replace(array('*', '%', '?', '/', '\\') , '', $newname);

				// Hello... first a point... this is not a super hidden secret file xD
				if ($newname{0} == '.')
					$newname = substr($newname, 1);
				
				// Okay some funny work... hope it work ;)				
				$newname = htmlentities($newname, ENT_QUOTES);
				$newname = str_replace(array("'", "", "`"), array("&#039;","&#039;","&#039;"), $newname);
				// Now make it a little bit nice for me ;P
				$newname = preg_replace('~&amp;#(\d{4,5}|[2-9]\d{2,4}|1[2-9]\d);~', '&#$1;', $newname);
				$new_names[$ID_ATTACH] = $newname;
			}
		}
		
		// Okay i will look if you allowed to change this names!
		if (!allowedTo('rename_attachments_any'))
		{
			$checkAttachIDs = array_keys($new_names);
			// Load the ID_MSG for the $checkAttachIDs
			$result = db_query("
				SELECT ID_MSG 
				FROM {$db_prefix}attachments
				WHERE ID_ATTACH IN (".implode(", ", $checkAttachIDs).")
				LIMIT ".count($checkAttachIDs), __FILE__, __LINE__);
			$collectIDMSG = array();
			while ($row = mysql_fetch_assoc($result))
				$collectIDMSG[$row['ID_MSG']] = $row['ID_MSG'];
			
			mysql_free_result($result);
			
			if (empty($collectIDMSG))
				fatal_error($txt['norightstorename']);
			
			// Okay i load now all the ID_MEMBERS of the posts...
			$result = db_query("
				SELECT ID_MEMBER 
				FROM {$db_prefix}messages
				WHERE ID_MSG IN (".implode(", ", $collectIDMSG).")
				LIMIT ".count($collectIDMSG), __FILE__, __LINE__);
			
			while ($row = mysql_fetch_assoc($result))
			{
				if ($row['ID_MEMBER'] != $ID_MEMBER)
				{
					mysql_free_result($result);
					fatal_error($txt['norightstorename']);
				}
			}
			mysql_free_result($result);
		}
		
		// Okay do some work ;)
		if (!empty($empty_to_old))
		{
			db_query("
				UPDATE {$db_prefix}attachments 
				SET renamedfilename = filename
				WHERE ID_ATTACH IN (".implode(", ", $empty_to_old).")
				LIMIT ".count($empty_to_old), __FILE__, __LINE__);
		}
		
		// New Names add them :)
		if (!empty($new_names))
		{
			foreach ($new_names as $ID_ATTACH => $filename)
				db_query("
					UPDATE {$db_prefix}attachments 
					SET renamedfilename = '{$filename}'
					WHERE ID_ATTACH = $ID_ATTACH
					LIMIT 1", __FILE__, __LINE__);		
		}
	}

	// Where should i go topic or attachment mangager
	if (empty($topic) && empty($_GET['msg']))
	{
		// Go to the First type i found :)
		reset($new_names);
		reset($empty_to_old);
		$ID_ATTACH = empty($new_names) ? current($empty_to_old) : key($new_names);
		if (empty($ID_ATTACH))
			redirectexit('action=manageattachments;sa=browse');
		// Find the pos you nearly like to go ;)
		$type = 0;
		$memID = 0;
		$request = db_query("SELECT ID_MEMBER, attachmentType FROM {$db_prefix}attachments WHERE ID_ATTACH = '$ID_ATTACH' LIMIT 1", __FILE__, __LINE__);
		list($memID, $type) = mysql_fetch_row($request);
		mysql_free_result($request);
		
		// GO GO GO!!!
		if (!empty($memID))
			redirectexit('action=manageattachments;sa=browse;avatars');
		if (!empty($type)) 
			redirectexit('action=manageattachments;sa=browse;thumbs');
		else
			redirectexit('action=manageattachments;sa=browse');
	}
	else
		redirectexit('topic='.$topic.'.msg'.$_GET['msg'].'#msg'.$_GET['msg']);
}
</add before>

<edit file>
$sourcedir/ManagePermissions.php
</edit file>

<search for>
		'post_reply_own',
		'post_reply_any',
</search for>

<add after>
		'rename_attachments_own',
</add after>

<search for>
		'poll_remove_any',
		'poll_add_any',
</search for>

<add after>
		'rename_attachments_any',
</add after>

<search for>
				'view_attachments' => false,
				'post_attachment' => false,
</search for>

<add after>
				'rename_attachments' => true,
</add after>

<search for>
		'manage_membergroups',
		'manage_permissions',
</search for>

<add after>
		'rename_attachments_own',
		'rename_attachments_any',
</add after>

<edit file>
$sourcedir/Subs-Post.php
</edit file>

<search for>
			(ID_MSG, filename, file_hash, size, width, height)
		VALUES (" . (int) $attachmentOptions['post'] . ", SUBSTRING('" . $attachmentOptions['name'] . "', 1, 255), '$attachmentOptions[file_hash]', " . (int) $attachmentOptions['size'] . ', ' . (empty($attachmentOptions['width']) ? '0' : (int) $attachmentOptions['width']) . ', ' . (empty($attachmentOptions['height']) ? '0' : (int) $attachmentOptions['height']) . ')', __FILE__, __LINE__);
</search for>

<replace>
			(ID_MSG, filename, renamedfilename, file_hash, size, width, height)
		VALUES (" . (int) $attachmentOptions['post'] . ", SUBSTRING('" . $attachmentOptions['name'] . "', 1, 255), SUBSTRING('" . $attachmentOptions['name'] . "', 1, 255), '$attachmentOptions[file_hash]', " . (int) $attachmentOptions['size'] . ', ' . (empty($attachmentOptions['width']) ? '0' : (int) $attachmentOptions['width']) . ', ' . (empty($attachmentOptions['height']) ? '0' : (int) $attachmentOptions['height']) . ')', __FILE__, __LINE__);
</replace>

<search for>
					(ID_MSG, attachmentType, filename, file_hash, size, width, height)
				VALUES (" . (int) $attachmentOptions['post'] . ", 3, SUBSTRING('$thumb_filename', 1, 255), '$thumb_file_hash', " . (int) $thumb_size . ", " . (int) $thumb_width . ", " . (int) $thumb_height . ")", __FILE__, __LINE__);
</search for>

<replace>
					(ID_MSG, attachmentType, filename, renamedfilename, file_hash, size, width, height)
				VALUES (" . (int) $attachmentOptions['post'] . ", 3,SUBSTRING('$thumb_filename', 1, 255), SUBSTRING('$thumb_filename', 1, 255), '$thumb_file_hash', " . (int) $thumb_size . ", " . (int) $thumb_width . ", " . (int) $thumb_height . ")", __FILE__, __LINE__);
</replace>

<edit file>
$themedir/Display.template.php
</edit file>

<search for>
				echo '
										<a href="' . $attachment['href'] . '"><img src="' . $settings['images_url'] . '/icons/clip.gif" align="middle" alt="*" border="0" />&nbsp;' . $attachment['name'] . '</a> (', $attachment['size'], ($attachment['is_image'] ? ', ' . $attachment['real_width'] . 'x' . $attachment['real_height'] . ' - ' . $txt['attach_viewed'] : ' - ' . $txt['attach_downloaded']) . ' ' . $attachment['downloads'] . ' ' . $txt['attach_times'] . '.)<br />';
			}
</search for>

<add after>
			if ($message['can_rename_attachment']) 
				echo '
										<a href="'.$scripturl.'?action=attachrename;topic='.$context['current_topic'].'.0;msg='.$message['id'].';sesc=', $context['session_id'], '"><span class="smalltext">'.$txt['renameattach'].'</span></a><br />';
</add after>


<edit file>
$themedir/ManageAttachments.template.php
</edit file>

<search for>
		</tr><tr class="windowbg2">
			<td width="50%" align="right"><label for="attachmentThumbHeight">', $txt['attachmentThumbHeight'], '</label>:</td>
			<td><input type="text" name="attachmentThumbHeight" id="attachmentThumbHeight" value="', empty($modSettings['attachmentThumbHeight']) ? '0' : $modSettings['attachmentThumbHeight'], '" size="6" /></td>
</search for>

<replace>
		</tr><tr class="windowbg2">
			<td width="50%" align="right"><label for="attachmentThumbHeight">', $txt['attachmentThumbHeight'], '</label>:</td>
			<td><input type="text" name="attachmentThumbHeight" id="attachmentThumbHeight" value="', empty($modSettings['attachmentThumbHeight']) ? '0' : $modSettings['attachmentThumbHeight'], '" size="6" /></td>
		</tr><tr class="windowbg2">
			<td colspan="2"><hr /></td>
		</tr><tr class="windowbg2">
			<td width="50%" align="right"><label for="attachmentCheckCensor">', $txt['attachmentCheckCensor'], ':</label></td>
			<td><input type="checkbox" name="attachmentCheckCensor" id="attachmentCheckCensor" value="1" class="check"', empty($modSettings['attachmentCheckCensor']) ? '' : ' checked="checked"', ' /></td>
</replace>

<search for>
	global $context, $settings, $options, $scripturl, $txt;

	echo '
</search for>

<add after>
<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
	var confirmthedelete = true;
	function returnConfirmSpecial()
	{
		if (confirmthedelete == true)
		{
			return confirm(\'', $txt['confirm_delete_attachments'], '\');		
		}
		else
		{
			return true;
		}
	}
	function setvaluefalse()
	{
		confirmthedelete = false;
	}
	function setvaluetrue()
	{
		confirmthedelete = true;	
	}
// ]]></script>
</add after>

<search for>
<form action="', $scripturl, '?action=manageattachments;sort=', $context['sort_by'], $context['sort_direction'] == 'down' ? ';desc' : '', ';sa=remove" method="post" accept-charset="', $context['character_set'], '" onsubmit="return confirm(\'', $txt['confirm_delete_attachments'], '\');">
</search for>

<replace>
<form action="', $scripturl, '?action=manageattachments;sort=', $context['sort_by'], $context['sort_direction'] == 'down' ? ';desc' : '', ';sa=remove" method="post" accept-charset="', $context['character_set'], '" onsubmit="return returnConfirmSpecial();">
</replace>

<search for>
			<td nowrap="nowrap"><a href="', $scripturl, '?action=manageattachments;sa=browse;', $context['browse_type'], ';sort=name', $context['sort_by'] == 'name' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt['smf213'], $context['sort_by'] == 'name' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" />' : '', '</a></td>
</search for>

<replace>
			<td nowrap="nowrap">
				<a href="', $scripturl, '?action=manageattachments;sa=browse;', $context['browse_type'], ';sort=name', $context['sort_by'] == 'name' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt['smf213'], $context['sort_by'] == 'name' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" />' : '', '</a>
				<a href="', $scripturl, '?action=manageattachments;sa=browse;', $context['browse_type'], ';sort=realname', $context['sort_by'] == 'realname' && $context['sort_direction'] == 'up' ? ';desc' : '', '"><span class="smalltext">(', $txt['attachorginalname'], ')</span>' , $context['sort_by'] == 'realname' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" />' : '', '</a>			
			</td>
</replace>

<search for>
				<input type="submit" name="remove_submit" value="', $txt['smf138'], '" />
</search for>

<replace>
				<input type="submit" name="rename" onclick="setvaluefalse();" value="', $txt['renameattachments'], '" />
				<input type="submit" name="remove_submit" onclick="setvaluetrue();" value="', $txt['smf138'], '" />
</replace>

<search for>
?>
</search for>

<add before>
function template_manage_rename()
{
	global $context, $settings, $options, $scripturl, $txt;

	echo '
<form action="', $scripturl, '?action=attachrename2" method="post" accept-charset="', $context['character_set'], '">
	<table border="0" align="center" cellspacing="1" cellpadding="4" class="bordercolor" width="100%">
		<tr class="titlebg">
			<td colspan="5">', $txt['attachment_manager_rename_files'], '</td>
		</tr>';

	// shall we use the tabs?
	if (!empty($settings['use_tabs']))
	{
		echo '
	</table>';

		echo '
	<table cellpadding="0" cellspacing="0" border="0" style="margin-bottom: 1ex; margin-left: 10px;">
		<tr>
			<td class="maintab_first">&nbsp;</td>
			<td class="maintab_back"><a href="', $scripturl, '?action=manageattachments;sa=browse">', $txt['attachment_manager_attachments'], '</a></td>
			<td class="maintab_back"><a href="', $scripturl, '?action=manageattachments;sa=browse;avatars">', $txt['attachment_manager_avatars'], '</a></td>
			<td class="maintab_back"><a href="', $scripturl, '?action=manageattachments;sa=browse;thumbs">', $txt['attachment_manager_thumbs'], '</a></td>
			<td class="maintab_last">&nbsp;</td>
		</tr>
	</table>';

		echo '
	<table border="0" align="center" cellspacing="1" cellpadding="4" class="bordercolor" width="100%">';
	}
	// if not, use the old style
	else
	{	
		echo '
		<tr class="catbg">
			<td colspan="5">
				<a href="', $scripturl, '?action=manageattachments;sa=browse">', $txt['attachment_manager_attachments'], '</a>&nbsp;|&nbsp;
				<a href="', $scripturl, '?action=manageattachments;sa=browse;avatars">', $txt['attachment_manager_avatars'], '</a>&nbsp;|&nbsp;
				<a href="', $scripturl, '?action=manageattachments;sa=browse;thumbs">', $txt['attachment_manager_thumbs'], '</a>
			</td>
		</tr>';
	}
	
	$alternate = false;
	foreach ($context['attachments'] as $attachment)
	{
		echo '
		<tr class="', $alternate ? 'windowbg' : 'windowbg2', '">
			<td align="center" colspan="5">
				'.$txt['attachcurrentname'].': <i>'.(!empty($attachment['renamedfilename']) ? $attachment['renamedfilename'] : $txt['search_no_results']).'</i> '.$txt['attachrenameto'].' <input type="text" size="50" name="renameto['.$attachment['ID_ATTACH'].']" value="'.$attachment['renamedfilename'].'" />
			</td>
		</tr>';
		
		$alternate = !$alternate;
	}
	echo '
		<tr class="', $alternate ? 'windowbg' : 'windowbg2', '">
			<td align="center" colspan="5">
				<input type="submit" name="save_submit" value="', $txt['renamesave'], '" />
				<input type="hidden" name="sc" value="', $context['session_id'], '" />
			</td>
		</tr>
		<tr class="catbg">
			<td align="left" colspan="5" style="padding: 5px;">&nbsp;</td>
		</tr>
	</table>
</form>';
}

function template_manage_rename2_above()
{
	global $context, $settings, $options, $scripturl, $txt;
}

function template_manage_rename2_below()
{
	global $context, $settings, $options, $scripturl, $txt;
}

function template_main()
{
	global $context, $settings, $options, $scripturl, $txt;

	echo '
<form action="', $scripturl, '?action=attachrename2;topic='.$context['topic'].'.0;msg='.$context['ID_MSG'].'" method="post" accept-charset="', $context['character_set'], '">
	<table border="0" align="center" cellspacing="1" cellpadding="4" class="bordercolor" width="100%">
		<tr class="titlebg">
			<td colspan="5">', $txt['attachment_manager_rename_files'], '</td>
		</tr>';
	
	$alternate = false;
	foreach ($context['attachments'] as $attachment)
	{
		echo '
		<tr class="', $alternate ? 'windowbg' : 'windowbg2', '">
			<td align="center" colspan="5">
				'.$txt['attachcurrentname'].': <i>'.(!empty($attachment['renamedfilename']) ? $attachment['renamedfilename'] : $txt['search_no_results']).'</i> '.$txt['attachrenameto'].' <input type="text" size="50" name="renameto['.$attachment['ID_ATTACH'].']" value="'.$attachment['renamedfilename'].'" />
			</td>
		</tr>';
		
		$alternate = !$alternate;
	}
	echo '
		<tr class="', $alternate ? 'windowbg' : 'windowbg2', '">
			<td align="center" colspan="5">
				<input type="submit" name="save_submit" value="', $txt['renamesave'], '" />
				<input type="hidden" name="sc" value="', $context['session_id'], '" />
			</td>
		</tr>
		<tr class="catbg">
			<td align="left" colspan="5" style="padding: 5px;">&nbsp;</td>
		</tr>
	</table>
</form>';
}
</add before>
